#!/usr/bin/env python
# 
# Brimstone
#
# Requires Python 2.4 or Greater, Pexpect, and Paramiko
#
# Copyright (c) 2010, Jr Aquino
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Names of its contributors may not be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.#
#############################################################################

version = '0.9.9'
import getpass, os, time, commands, sys, signal, re, optparse, platform
import urllib2, threading, socket, cStringIO
import Queue
from threading import Thread
from time import sleep

import warnings
warnings.filterwarnings("ignore")
try:
    import pexpect, paramiko
except ImportError:
    print '''
    Warning: pexpect library not found! Downloading setuptools installer.
    Run "sudo ./ez_setup.py".
    When that is finished, run "sudo easy_install pexpect".
    When that is finished, run "sudo easy_install paramiko".'''
    ez_setup = open('ez_setup.py', 'w')
    request = urllib2.urlopen("http://peak.telecommunity.com/dist/ez_setup.py")
    html = request.readlines()
    html[0] = '#!/usr/bin/env python\n'
    for line in html:
        ez_setup.write(line)
    ez_setup.close()
    os.chmod('ez_setup.py', 0755)
    sys.exit(2)
try:
    import yaml
except ImportError:
    print '''
    Warning: yaml library not found! Downloading setuptools installer.
    Run "sudo ./ez_setup.py".
    When that is finished, run "sudo easy_install PyYaml".'''
    ez_setup = open('ez_setup.py', 'w')
    request = urllib2.urlopen("http://peak.telecommunity.com/dist/ez_setup.py")
    html = request.readlines()
    html[0] = '#!/usr/bin/env python\n'
    for line in html:
        ez_setup.write(line)
    ez_setup.close()
    os.chmod('ez_setup.py', 0755)
    sys.exit(2)

class bcolors:
    HEADER = '\033[95m'
    OKBLUE = '\033[94m'
    OKGREEN = '\033[92m'
    WARNING = '\033[93m'
    RED = '\033[91m'
    ENDC = '\033[0m'

    def disable(self):
        self.HEADER = ''
        self.OKBLUE = ''
        self.OKGREEN = ''
        self.WARNING = ''
        self.FAIL = ''
        self.ENDC = ''
            
class hyperActive(Thread):
    "Going to HyperActive"
    
    def __init__ (self, host):
        Thread.__init__(self)
        self.host  = host
        self.status = -1
    def run(self):
        "Run a command via threading"
        
        status, output = commands.getstatusoutput('ping -c2 -W2 %s' % self.host)
        status >>= 8
        if status == 64: # Compatability with BSD/OSX ping
            status, output = commands.getstatusoutput('ping -c2 -t2 %s'
                                                        % self.host)
        self.status = status
        
class hyperSsh(Thread):
    "Going to HyperActive"
    
    def __init__ (self, scp, pw, cmd, q, timeout):
        Thread.__init__(self)
        
        self.q = q
        self.cmd = cmd
        self.pw = pw
        self.scp_file = scp
        self.pid = ''
        self.debug = None # Debuging
        socket.setdefaulttimeout(timeout)
        paramiko.util.log_to_file('paramiko.log')
                   
    def run(self):
        "Run ssh command(s) via threading"

        global done        
        while not done:
            try:
                self.host = self.q.get(0)
                if self.scp_file == None:
                    self.ssh()
                else:
                    for filename in (self.scp_file.split(',')):
                        self.scp(filename)
                    if options.command:
                        self.ssh()
            except Queue.Empty:
                done = True
                break

    def exitMsg(self, hostname, command, data, start_time, statusMsg):
        "Print thread exit message"
        
        logfile = open('coal.log', 'a')
        end_time = time.time()
        ctime = time.ctime()
        duration =  end_time - start_time
        globals()['headcount'] -= 1
        print (bcolors.RED + '\n<<< %s >>> \n' % (hostname) + bcolors.ENDC)
        print '%s' % (data)
        print (bcolors.OKGREEN +
                '\nCompleted in %.2f seconds. %s of %s remaining.\n'
                % (duration, headcount, alive) + bcolors.ENDC)
        log_output = ('%(statusMsg)s[%(ctime)s] %(hostname)s '
                        '"%(command)s"\n' % locals())
        logfile.write(log_output)
        return
         
    def ssh(self):
        "Paramiko Native Standard Run with just ssh"

        logfile = open('coal.log', 'a')
        verbose = options.verbose
        start_time = time.time()
        command = options.command
        hostname = self.host
        username = getpass.getuser()
        password = self.pw
        port = 22
        scp = options.scp
        output = ''
        errors = ''
        sudo_check = re.compile(r'sudo ')
        sudo = sudo_check.search(command)
        ssh = paramiko.SSHClient()
        ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
        try:
            ssh.connect(hostname, port, username, password)
        except paramiko.AuthenticationException, e:
            error = 'Authentication Failed'
            self.exitMsg(hostname, command, error, start_time, 'Failed: ')
            return
        except socket.timeout:
            error = 'Timeout'
            self.exitMsg(hostname, command, error, start_time, 'Failed: ')
            return
        except socket.error:
            error = 'Timeout'
            self.exitMsg(hostname, command, error, start_time, 'Failed: ')
            return
        except paramiko.SSHException, e:
            error = 'SSH Failure: %s' % (e)
            self.exitMsg(hostname, command, error, start_time, 'Failed: ')
            return
        except EOFError, e:
            error = 'Failed: %s' % (e)
            self.exitMsg(hostname, command,error, start_time, 'Failed: ')
            return
        if sudo:
            sudo_flush = 'sudo -K'
            stdin, stdout, stderr = ssh.exec_command(sudo_flush)
        try:
            stdin, stdout, stderr = ssh.exec_command(command)
            if sudo:
                stdin.write(password)
                stdin.write('\n')
                sudo_flush = 'sudo -K'
                sudoin, sudoout, sudoerr = ssh.exec_command(sudo_flush)
                output = stdout.readlines()
                errors = stderr.readlines()
            else:
                output = stdout.readlines()
                errors = stderr.readlines()

        except AttributeError, e:
            print "%s: %s" % (hostname, e)

        if command:
            ctime = time.ctime()
            if not output:
                statusMsg = 'Failed: '
                if errors:
                    for line in errors:
                        print line,
                else:
                    print 'Unexpected Error occured'
                log_output = ('%(statusMsg)s[%(ctime)s] %(hostname)s '
                                '"%(command)s"\n' % locals())
                logfile.write(log_output)
            else:
                data = cStringIO.StringIO()
                for line in output:
                    data.write(line,)
                data = data.getvalue()
                statusMsg = 'Succeeded: '
                self.exitMsg(hostname, command, data, start_time, statusMsg)
                if verbose:
                    log_output = ('%(statusMsg)s[%(ctime)s] %(hostname)s '
                                    '"%(command)s"\n%(data)s\n' % locals())
                else:
                    log_output = ('%(statusMsg)s[%(ctime)s] %(hostname)s '
                                    '"%(command)s"\n' % locals())
                logfile.write(log_output)        
        ssh.close()
        return

    def scp(self, filename):
        "SCP Files before commands are run"

        hostname = self.host
        username = getpass.getuser()
        password = self.pw
        port = 22
        remotepath = os.path.basename(filename)

        transport = paramiko.Transport((hostname, port))
        transport.connect(username = username, password = password)
        sftp = paramiko.SFTPClient.from_transport(transport)
        try:
            sftp.put(filename, remotepath)
        except IOError, e:
            print ('Transfer failed for %s: %s' % (remotepath, e))
            sftp.close()
            transport.close()
            return
        sftp.close()
        transport.close()
        return

class Brimstone(object):
    "The Brimstone Class"
    
    def __init__(self):
        self.hostnames = []
        self.alive = []
        self.dead = []
        self.password = ''
        self.default_realm = ''

    def krbCheck(self):
        "Check Default Realm Kerberos Configuration"

        realm_check = re.compile(r'^\s+default_realm\s+=\s+(.*)')
        if os.path.exists('/etc/krb5.conf'):
            try:
                krb5_conf = open('/etc/krb5.conf', 'r').readlines()
                for line in krb5_conf:
                    realm_match = realm_check.search(line)
                    if realm_match:
                        realm = realm_match.group(1).strip()
                        self.default_realm = '@%s' % realm
            except IOError, e:
                print "Can't read kerberos config: %s" % e
                sys.exit(2)

    def getHostFile(self, filename):
        "Read in the hosts from a file"
        
        try:
            self.hostnames = open(filename, 'r').readlines()
            self.hostnames = [ h.strip() for h in self.hostnames ]
        except IOError, e:
            print ("Error loading host list. \n%s" % (e))
            sys.exit(2)
        
    def getHostStdin(self, standard_in):
        "Read in the hosts from standard in"

        self.hostnames = [ h.strip() for h in standard_in ]
        if not self.hostnames:
            print "No hosts given via standard in"

    def getHostsForeman(self):
        "Read in hosts from Foreman Yaml"
        
        facts_of_life = []
        head_of_the_class = []
        
        if options.facts:
            for fact in options.facts.split(','):
                fact = 'fact[]=%s&' % fact
                facts_of_life.append(fact)
        if options.classes:
            for puppet_class in options.classes.split(','):
                puppet_class = 'class[]=%s&' % puppet_class
                head_of_the_class.append(puppet_class)
        
        foreman = options.puppet
        facts = ''.join(facts_of_life)
        classes = ''.join(head_of_the_class)
        
        url = ('http://%s/hosts/query?%s%sstate=all&format=yml' 
                % (foreman, facts, classes))
        host_yaml = urllib2.urlopen(url)
        self.hostnames = yaml.load(host_yaml)
        self.hostnames = [ h.strip() for h in self.hostnames]
        
    def stickPoke(self):
        "Check hosts for life signs"
        
        # Confirm status for hosts
        pinglist = []
        for host in self.hostnames:
            hoststatus = hyperActive(host)
            pinglist.append(hoststatus)
            hoststatus.start()
            
        for pingle in pinglist:
            pingle.join()
    
            if not pingle.status:
                self.alive.append(pingle.host)
            else:
                self.dead.append(pingle.host)
        if self.dead:
            print (bcolors.WARNING + 
                    'WARN: The Following host(s) did not ping:\n\n'
                    + bcolors.ENDC)
            bodycount = 0
            graveyard = {}
            for body in self.dead:
                bodycount = bodycount + 1
                graveyard[bodycount] = body
            
            for number in graveyard:
                print (bcolors.OKGREEN + 
                        '[%s] ' % number + bcolors.RED + graveyard[number]
                        + bcolors.ENDC)
            zombies = raw_input('\nIf you know there are hosts with firewalls '
                                'blocking icmp,\n choose them now otherwise '
                                'just press enter\n...i.e. 1,2,3: ')
            if zombies:
                zombies = zombies.strip().split(',')
                for body in zombies:
                    body = int(body)
                    try:
                        corpse = graveyard[body]
                        print corpse
                    except KeyError:
                        print 'Invalid number: %s' % body
                        continue
                    self.alive.append(corpse)
    
            answer = raw_input('\nContinue [Y/n]: ')
            if answer == 'n':
                print 'Aborting...\n'
                sys.exit(1)
            elif not self.alive:
                print 'There are no hosts left alive, Aborting...\n'
                sys.exit(1)
        
    def kinitUser(self):
        "Use pexpect to require kinit"
        
        # Place holder for when paramiko supports GSSAPI
        username = getpass.getuser()
        if username == 'root':
            print 'Do not run this tool as root.'
            sys.exit(1)
        self.password = getpass.getpass('Please enter the password for %s%s: '
                                        % (username, self.default_realm))
        self.alt_password = getpass.getpass('Alternate Password: ')
        child = pexpect.spawn('/usr/bin/env kinit')
        child.expect('[Pp]assword for %s@.*\.COM:' % getpass.getuser())
        child.sendline(self.password) 
        child.expect(pexpect.EOF) 
        print child.before
        child.close()
        if child.exitstatus:
            sys.exit(child.exitstatus)
        return
    
    def checkKlist(self):
        "Check to see if we alrady have a kerberos ticket"
        
        # Place holder for when paramiko supports GSSAPI
        cmd, output, error = os.popen3('klist')
        if output.read():
            # User has ticket
            #self.password = getpass.getpass('Password: ')
            self.kinitUser()
        elif error.read():
            self.kinitUser()
        return
    
    def getPassword(self, wrong = 0):
        "Confirm user's password"
        
        self.password = getpass.getpass()
        confirm = getpass.getpass('Confirm: ')
        if self.password != confirm:
            print ('Passwords do not match!')
            if not wrong:
                self.getPassword(1)
            else:
                print ("The fingers you have used to dial are too fat. "
                        "To order a special dialing wand, please mash the "
                        "keypad with your palm now.")
                sys.exit(3)
        else:
            confirm = None
        return
        
    def startEngine(self):
        "The real workload"
        
        status = ('Succeeded: ', 'Failed: ')
        self.threads = []
        logname = 'coal.log'
        logfile = open(logname, 'w')
        global done
        done = False        
        global alive
        global headcount
        global q
        alive = len(self.alive)
        headcount = len(self.alive)
        jobs = options.jobs
        q = Queue.Queue()
        
        print (bcolors.OKBLUE + 'Welcome to Brimstone' + bcolors.ENDC)
        # Add hosts to the queue
        for host in self.alive:
            q.put(host)
        
        if jobs > 0:    
            for n in range(jobs):
                thread = (hyperSsh(options.scp, self.password, options.command, 
                            q, options.timeout))
                self.threads.append(thread)
                thread.setDaemon(True)
                thread.start()
            
            for t in self.threads:
                t.join()
        else:
            print 'You must specify a valid number of jobs to run in paralell'
            sys.exit(1)

def myhandler(signal, frame):
    "Kill Child Threads and Spawn"
    global done
    done = True
    logfile = open('coal.log', 'a')
    escape_message = '\nBrimstone stopped'
    print escape_message
    for cmd in threading.enumerate():
        if cmd.getName() != 'MainThread':
            print dir(cmd)
            logfile.write(escape_message)
            cmd._Thread__stop()
            sys.exit(1)

def infohandler(signal, frame):
    "Check remaining Threads"

    for cmd in threading.enumerate():
        if cmd.getName() != 'MainThread':
            print cmd

def main(options, args):
    # Main Execution of Code
    
    # Signal Catchers
    signal.signal(signal.SIGTERM, myhandler)
    signal.signal(signal.SIGINT, myhandler)
    signal.signal(signal.SIGHUP, myhandler)
    if platform.system() == 'Linux':
        signal.signal(signal.SIGQUIT, infohandler)
    else:
        signal.signal(signal.SIGINFO, infohandler)
    
    # Initiate Class
    brimstone = Brimstone()
    
    # Determine if hosts are received from standard in or via filename
    if options.filename:
        brimstone.getHostFile(options.filename)
    elif (options.facts or options.classes):
        brimstone.getHostsForeman()
    elif options.command:
        brimstone.getHostStdin(sys.stdin.readlines())
        sys.stdin = open("/dev/tty")
        
    # If testing, just print out the host list and exit
    if options.test:
        for host in brimstone.hostnames:
            print host
        sys.exit(1)
    
    if not options.timeout:
        print "Warning: No timeout set.\nYour jobs will be dependant on default TCP timeouts."
    # Check to see if Hosts are alive
    brimstone.stickPoke()
    
    # Setup Authentication    
    brimstone.getPassword()
                
    # Run Commands
    brimstone.startEngine()
        
def parseOptions():
    "The Options engine; some options are not optional"

    parser = optparse.OptionParser("Usage: %prog [-f|--file <FILE>] "
                                    "[-p <puppet-foreman server>]"
                                    "[-F <facts,...>] [-C <class,...>] "
                                    "[-s|--scp <FILE>] {[-c|--command] "
                                    "[-t|--test] <CMD>}")
    parser.add_option("-f", "--file", dest="filename",
                    default=None, type="string", 
                    help="File containing list of target hosts, one per line.")

    parser.add_option("-c", "--command", dest="command",
                    default=None, type="string",
                    help="Command(s) to execute on each target host.")

    parser.add_option("-j", "--jobs", dest="jobs",
                    default=2, type="int", 
                    help="Set number of parallel jobs for ssh.")

    parser.add_option("-p", "--puppet-foreman", dest="puppet",
                    default=None, type="string", 
                    help="Puppet Foreman Server.")

    parser.add_option("-F", "--facts", dest="facts",
                    default=None, type="string", 
                    help="Puppet facts as read by foreman.")

    parser.add_option("-C", "--classes", dest="classes",
                    default=None, type="string", 
                    help="Puppet classes as read by forman.")
                    
    parser.add_option("-s", "--scp", dest="scp",
                    default=None, type="string", 
                    help="File(s) to scp to each target host before running "
                     "<CMD> (files will go to your ~home).")

    parser.add_option("-T", "--test", dest="test",
                    action="store_true", default=False, 
                    help="Enable hostlist testing.")

    parser.add_option("-t", "--timeout", dest="timeout",
                    default=0, type="int", 
                    help="Set timeout for ssh.")

    parser.add_option("-v", "--verbose", dest="verbose",
                    action="store_true", default=False, 
                    help="Enable verbose logging.")

    parser.add_option("-V", "--version", dest="version",
                    action="store_true", default=False, 
                    help="Display brimpstone version.")
                    
    (options, args) = parser.parse_args()

    if options.version:
        print '%s %s' % (os.path.basename(sys.argv[0]), version)
        sys.exit(0)
    if not (options.command or options.scp):
        parser.error("You must specify an option. Use -h for help.")
    if ((options.filename or options.facts or options.classes) and not 
        (options.command or options.scp)):
        parser.error("You must specify an option. Use -h for help.")
    return options, args

if __name__ == '__main__':
    options, args = parseOptions()
    main(options, args)
